/*
 * Code to handle basic data structures
 * 2002-2003 HShivanan
 * 
 * For licensing terms, see the file COPYING
 * For contact information, see the file AUTHORS
 */
#include <stdio.h>
#include <string.h>
#include "item.h"
#include "stuff.h"
int expand_list(ITEM_LIST **i)
{
	int new_cap;
	ITEM **d;
	new_cap=(*i)->capacity;
	new_cap*=2;
	d=fn_realloc((*i)->items,new_cap*sizeof(ITEM *));
	if (d)
	{
		(*i)->items=d;
		(*i)->capacity=new_cap;
		return new_cap;
	}else
	{
 		printf("mefn_malloc error\n");
		return -1;
	}
	
}
int add_item_item (ITEM_LIST ** il, ITEM * i)
{
	return add_item (il,i->channel,i->item,i->link,i->description);
}
int add_item(ITEM_LIST **il,char * channel,char *item,char *link,
		char *description)
{
	ITEM *i;
	i=(ITEM *)fn_malloc(sizeof(ITEM));
	ASSERT(i!=NULL);
	if ( (*il)->count >= (*il)->capacity )
		if (!expand_list(il))
			return -1;
// 	i->item=item;
// 	i->channel=(char *)fn_malloc(strlen(channel)+1);
// 	i->channel[strlen(channel)]=0;
// 	memcpy(i->channel,channel,strlen(channel));
// 	i->link=link;
// 	i->description=description;
#define cp(x) if (x) i->x = duplicate_str(x);else i->x=NULL
	cp(link);
	cp(channel);
	cp(item);
	cp(description);
	(*il)->items[(*il)->count++]=i;
	return 1;
}


ITEM_LIST *new_item_list(const size_t size)
{
	ITEM **i;
	ITEM_LIST *il=(ITEM_LIST *)fn_malloc(sizeof(ITEM_LIST));
	il->count=0;
	i=(ITEM **)fn_malloc(sizeof(ITEM *)*size);
	il->items=i;
	il->capacity=size;
	return il;
}
void free_item_list(ITEM_LIST *il)
{
	int i;
	ITEM *item;
	for (i=0;i<(il->count);i++)
	{
		item=il->items[i];
		ASSERT(item!=NULL);
		if (item->item)
			fn_free(il->items[i]->item);
		if (item->description)
			fn_free(il->items[i]->description);
		if (item->channel)
			fn_free(il->items[i]->channel);
		if (item->link)
			fn_free(il->items[i]->link);
		fn_free(item);
	}
	fn_free(il->items);
	fn_free(il);
}


/*scoring stuff*/

int expand_score_list(SCORE_LIST **i)
{
	int new_cap;
	SCORE_ITEM **d;
	new_cap=(*i)->capacity;
	new_cap*=2;
	d=fn_realloc((*i)->items,new_cap*sizeof(SCORE_ITEM *));
	if (d)
	{
		(*i)->items=d;
		(*i)->capacity=new_cap;
		return new_cap;
	}else
	{
 		printf("mefn_malloc error\n");
		return -1;
	}
	
}
int add_score(SCORE_LIST **il,int score,int category,char *pattern,
		size_t pattern_len)
{
 	SCORE_ITEM *i;
	i=(SCORE_ITEM *)fn_malloc(sizeof(SCORE_ITEM));
	ASSERT(i!=NULL);
	if ( (*il)->count >= (*il)->capacity )
		if (!expand_score_list(il))
			return -1;
	i->score=score;
	i->category=category;
	i->pattern=(char *)fn_malloc(pattern_len+1);
	i->pattern[pattern_len]=0;
	memcpy(i->pattern,pattern,pattern_len);
	(*il)->items[(*il)->count++]=i;
	return 1;
}
SCORE_LIST *new_score_list(const size_t size)
{
	SCORE_ITEM **i;
	SCORE_LIST *il=(SCORE_LIST *)fn_malloc(sizeof(SCORE_LIST));
	il->count=0;
	i=(SCORE_ITEM **)fn_malloc(sizeof(ITEM *)*size);
	il->items=i;
	il->capacity=size;
	return il;
}
void free_score_list(SCORE_LIST *il)
{
	int i;
	SCORE_ITEM *item;
	for (i=0;i<(il->count);i++)
	{
		item=il->items[i];
		ASSERT(item!=NULL);
		if (item->pattern)
			fn_free(il->items[i]->pattern);
		fn_free(item);
	}
	fn_free(il->items);
	fn_free(il);
}
